/************************************************************
 **
 ** bsc_decl.h : BSC file declarations
 **
 ** Copyright (c) 2004, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef bsc_decl_h__
#define bsc_decl_h__

#define BSC_TOKEN_SIZE_MAX 1024

#define BSC_FILE_FLAG_PRINT  0x0001 /* need the print function        */
#define BSC_FILE_FLAG_SPRINT 0x0002 /* need the signed print function */

struct bsc_file_ {
  pfile_t    *pf;       /* the pcode file */
  const char *inc_path; /* include path   */
  bsc_pass_t  pass;     /* pass #         */
  label_t    *isrs[1 + bsc_isr_type_ct];
  size_t      str_ct;   /* # of strings   */
  size_t      str_nxt;  /* next string ID */

  char        token[BSC_TOKEN_SIZE_MAX];
  size_t      token_len;
  flag_t      flags;
};

#endif

