#ifndef bsc_msg_h__
#define bsc_msg_h__

#define BSC_MSG_EXTRA_CHAR_ON_LINE     "extra characters on line ignored"
#define BSC_MSG_CONSTANT_EXPECTED      "constant expression expected"
#define BSC_MSG_SYNTAX_ERROR           "syntax error"
#define BSC_MSG_MULTI_DEF              "'%s' previously defined"
#define BSC_MSG_NEVER_USED             "'%s' defined but not used"
#define BSC_MSG_NEVER_ASSIGNED         "'%s' is never assigned a value"
#define BSC_MSG_ASSIGN_NOT_USED        "'%s' is assigned but not used"
#define BSC_MSG_NEVER_DEFINED          "'%s' not defined"
#define BSC_MSG_END_EXPECTED           "'%s' expected for block starting on" \
                                       " line %u"
#define BSC_MSG_PATH_TOO_LONG          "path too long"
#define BSC_MSG_CANNOT_OPEN            "cannot open '%s'"
#define BSC_MSG_COMPILING_PASS         "compiling pass...%u"
#define BSC_MSG_OSCILLATOR_BAD         "'crystal' or 'rc' expected"
#define BSC_MSG_ON_OR_OFF              "'on' or 'off' expected"
#define BSC_MSG_FILENAME_BAD           "filename expected"
#define BSC_MSG_SUBSCRIPT_BAD          "subscript out of range"
#define BSC_MSG_VALUE_EXPECTED         "value expected"
#define BSC_MSG_CMD_NOT_AVAIL          "'%s' not available"
#define BSC_MSG_INTERRUPTS_NOT_ENABLED "interrupts never enabled"
#define BSC_MSG_VARIABLE_EXPECTED      "variable name expected"
#define BSC_MSG_STRING_EXPECTED        "string expected"
#define BSC_MSG_CONSTANT_RANGE         "constant out of range"
#define BSC_MSG_ZERO_SZ                "cannot take part of this value"
#define BSC_MSG_ARRAY_SZ_ZERO          "array size must be > 0"
#define BSC_MSG_LOOKUP_TOO_BIG         "constant arrays are limited to" \
                                       " 254 elements"
#define BSC_MSG_ARRAY_INIT             "only the first %u of %u elements of" \
                                       " %s have been initialized"
#define BSC_MSG_TYPE_BAD               "type expected"
#define BSC_MSG_COMP_DATE              "picbsc 0.9 (compiled %s)"
#define BSC_MSG_EXPECTED               "'%s' expected"
#define BSC_MSG_INTERNAL_ERROR         "internal error"

#define BSC_MSG_DBG_INCLUDE            "including '%.*s'"

#define PFILE_MSG_DBG_LOOP             "loop:"
#define PFILE_MSG_DBG_LOOP_DST         " --> %s"
#define PFILE_MSG_DBG_LABEL_LEAK       "!!! label == %s"
#define PFILE_MSG_DBG_VAR_LEAK         "!!! var = %s"
#define PFILE_MSG_DBG_CONST_LEAK       "!!! var = %lu"
#define PFILE_MSG_DBG_CMD_FREED        "%u commands freed"
#define PFILE_MSG_DBG_LABELS_REMOVED   "%u %s labels removed"
#define PFILE_MSG_INTERNAL_ERROR       "internal error %s"
#define PFILE_MSG_NOT_FOUND            "'%s' not found"
#define PFILE_MSG_ASSIGN_TO_CONST      "assign to constant"
#define PFILE_MSG_DIVIDE_BY_ZERO       "divide by 0"
#define PFILE_MSG_PCODE_OPT            "p-code optimizer"
#define PFILE_MSG_DUMPING_RESULT       "writing result"

#define PIC_MSG_CONSTANT_RANGE         "constant out of range"
#define PIC_MSG_NO_USER_ENTRY          "no user entry"
#define PIC_MSG_CODE_USED              "Code area: %u of %u used"
#define PIC_MSG_CODE_TOO_BIG           "PIC image too big!"
#define PIC_MSG_FINDING_INTRIN         "finding intrinsics"
#define PIC_MSG_GENERATING_CODE        "generating PIC code pass %u"
#define PIC_MSG_FIXING_DATA_BITS       "fixing up data bits (STATUS<RP1:RP0>)"
#define PIC_MSG_FIXING_CODE_BITS       "fixing up code bits (PCLATH<4:3>)"
#define PIC_MSG_RANGE_INVALID          "invalid range"
#define PIC_MSG_PICLOADER_START_BAD    "picloader start must be less than" \
                                       " code size"
#define PIC_MSG_PRAGMA_UNKNOWN         "unknown pragma: '%s'"
#define PIC_MSG_LABEL_NOT_FOUND        "'%s' not found"
#define PIC_MSG_CODEGEN_ERROR          "code generation error (cmd# %u)"
#define PIC_MSG_NO_DATA_SPACE          "no room to allocate '%s'"
#define PIC_MSG_SPANS_BANKS            "'%s' spans %u banks"
#define PIC_MSG_CANNOT_ALLOCATE_CODEGEN "cannot allocate codegen. need %u" \
                                        " bytes at the start of bank 0"
#define PIC_MSG_ALLOCATING_VARS        "allocating variabled"
#define PIC_MSG_DATA_USED              "Data ares: %u of %u used"
#define PIC_MSG_DBG_INSERTED_INST      "...inserted %u instructions in %u"\
                                       " passes"
#define PIC_MSG_DBG_MUL_SZ             "...multiply %u bits"
#define PIC_MSG_DBG_DIV_SZ             "...divide %u bits"
#define PIC_MSG_DBG_BANK               "...bank %u...%u"
#define PIC_MSG_DBG_DATA_USED          "...data used %u"

#endif /* bsc_msg_h__ */

