/************************************************************
 **
 ** bsc_tokn.h : BSC token declarations
 **
 ** Copyright (c) 2004, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef bsc_tokn_h__
#define bsc_tokn_h__

#include "bsc_file.h"

typedef enum bsc_token_get_ { 
  bsc_token_first, 
  bsc_token_current, 
  bsc_token_next 
} bsc_token_get_t;

const char *bsc_token_get(bsc_file_t *pf, bsc_token_get_t which);
void        bsc_token_set(bsc_file_t *pf, const char *token);
const char *bsc_token_hack(bsc_file_t *pf);

result_t bsc_token_to_str(bsc_file_t *pf, pfile_log_t plog, value_t **dst);
result_t bsc_token_to_constant(bsc_file_t *pf, pfile_log_t plog, value_t **dst);
result_t bsc_identifier_to_value(bsc_file_t *pf, pfile_log_t plog, 
  const char *id, value_t **dst);
result_t bsc_token_to_value(bsc_file_t *pf, pfile_log_t plog, value_t **dst);
result_t bsc_token_to_label(bsc_file_t *pf, pfile_log_t plog, boolean_t alloc,
    label_t **dst);

boolean_t bsc_token_is(bsc_file_t *pf, bsc_token_get_t which, pfile_log_t plog,
  const char *str);
boolean_t bsc_token_is_eof(bsc_file_t *pf);
boolean_t bsc_token_is_eos(bsc_file_t *bsc);

typedef boolean_t (*bsc_token_parse_allow_cb_t)(int ch);

#define BSC_TOKEN_PARSE_ALLOW_STORE 0x0001 /* store the result in token    */
#define BSC_TOKEN_PARSE_ALLOW_UNGET 0x0002 /* unget first not allowed char */
int bsc_token_parse_allow(
  bsc_file_t                *bsc,
  bsc_token_parse_allow_cb_t allow,
  flag_t                     flags);

const char *bsc_token_ptr_get(bsc_file_t *bf);
void        bsc_token_ch_append(bsc_file_t *bf, int ch);
void        bsc_token_reset(bsc_file_t *bf);

result_t bsc_identifier_to_value(bsc_file_t *bsc, pfile_log_t plog, 
  const char *id, value_t **dst);
result_t bsc_identifier_to_variable(bsc_file_t *bsc, pfile_log_t plog,
  const char *id, variable_t **dst);

#endif /* bsc_tokn_h__ */

