/************************************************************
 **
 ** pfiledcl.h : p-code file declarations
 **
 ** Copyright (c) 2004, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef pfiledcl_h__
#define pfiledcl_h__

struct pfile_ {
  flag_t          flags;
  pfile_source_t *src;
  FILE           *f_asm;      /* asm output  */
  FILE           *f_lst;      /* list output */
  FILE           *f_hex;      /* hex output  */
  FILE           *f_log;      /* log output  */

  unsigned        errct;      /* # of errors found         */

  cmd_t      *cmds;       /* list of commands          */

  varlist_t   var_active; /* active variables          */
  varlist_t   var_const;  /* unnamed constants         */
  varlist_t   var_temp;   /* temporary variables       */
  varlist_t   var_isr;    /* isr temporary variables   */

  lbllist_t   label_user;      /* user defined labels       */
  unsigned    label_temp_ct;   /* next temp. id             */
  lbllist_t   label_temp;      /* temporary labels          */
  label_t    *label_temp_ptr;  /* pointer to next avail.
                                 temp. label               */
  label_t    *label_next;      /* label for the next line   */

  label_t    *label_main;         /* entry point to the program       */
  label_t    *label_isr;          /* entry point to the program's isr */
  label_t    *label_isr_preamble; /* entry to the isr preamble        */
  /* the following are for hex out */
  struct {
    unsigned      pc;         /* PC at the start of the line */
    unsigned      ct;         /* # of bytes in the buffer    */
    unsigned char buf[16];    /* data buffer                 */
  } hex;

  oscillator_t    osc;
};

#endif /* pfiledcl_h__ */

