/************************************************************
 **
 ** var_decl.h : value declarations
 **
 ** Copyright (c) 2004, Kyle A. York
 ** All rights reserved
 **
 ************************************************************/
#ifndef val_decl_h__
#define val_decl_h__

/* about ct_ofs : this can be changed if a value is a sub-part
 *                of an array. For example, say the full array
 *                is 10, but the returned part is [3..5] then
 *                ct_ofs will be 3, and ct will be 3 (3,4,5) */
struct value_
{
  variable_t     *var;       /* base variable                      */
  variable_t     *subscript; /* element #offset from base variable */
  variable_base_t baseofs;   /* offset from base                   */
  variable_sz_t   sz;        /* resulting size                     */
  variable_ct_t   ct;        /* resulting count                    */
  variable_ct_t   ct_ofs;    /* count offset                       */
  refct_t         ref_ct;
};

#endif /* val_decl_h__ */

